jamesh
Raspberry Pi Engineer & Forum Moderator
Raspberry Pi Engineer & Forum Moderator
Posts: 23708
Joined: Sat Jul 30, 2011 7:41 pm

Re: Moving Linux kernel to 4.19

Mon Oct 22, 2018 12:02 pm

cjan wrote:
Mon Oct 22, 2018 11:39 am
4.19 is out.
Not in the apt repos yet, still testing AFAIK.
Principal Software Engineer at Raspberry Pi (Trading) Ltd.
Contrary to popular belief, humorous signatures are allowed. Here's an example...
"My grief counseller just died, luckily, he was so good, I didn't care."

User avatar
DougieLawson
Posts: 36165
Joined: Sun Jun 16, 2013 11:19 pm
Location: Basingstoke, UK
Contact: Website Twitter

Re: Moving Linux kernel to 4.19

Mon Oct 22, 2018 12:45 pm

jamesh wrote:
Mon Oct 22, 2018 12:02 pm
cjan wrote:
Mon Oct 22, 2018 11:39 am
4.19 is out.
Not in the apt repos yet, still testing AFAIK.
It's still "4.18.14 commmit 7cf6484" (complete with the broken GoogleVoiceHat stuff) at: https://github.com/hexxeh/rpi-firmware/tree/next
Note: Having anything humorous in your signature is completely banned on this forum. Wear a tin-foil hat and you'll get a ban.

Any DMs sent on Twitter will be answered next month.

This is a doctor free zone.

DirkS
Posts: 9943
Joined: Tue Jun 19, 2012 9:46 pm
Location: Essex, UK

Re: Moving Linux kernel to 4.19

Mon Oct 22, 2018 1:11 pm

I think @cjan was referring to the official release of 4.19
https://www.phoronix.com/scan.php?page= ... e-Released

User avatar
DougieLawson
Posts: 36165
Joined: Sun Jun 16, 2013 11:19 pm
Location: Basingstoke, UK
Contact: Website Twitter

Re: Moving Linux kernel to 4.19

Mon Oct 22, 2018 1:53 pm

DirkS wrote:
Mon Oct 22, 2018 1:11 pm
I think @cjan was referring to the official release of 4.19
https://www.phoronix.com/scan.php?page= ... e-Released
That's off-topic to this thread, which is exclusively about 4.19 on Raspberries with the RPF fork of the kernel.
Note: Having anything humorous in your signature is completely banned on this forum. Wear a tin-foil hat and you'll get a ban.

Any DMs sent on Twitter will be answered next month.

This is a doctor free zone.

dom
Raspberry Pi Engineer & Forum Moderator
Raspberry Pi Engineer & Forum Moderator
Posts: 5331
Joined: Wed Aug 17, 2011 7:41 pm
Location: Cambridge

Re: Moving Linux kernel to 4.19

Mon Oct 22, 2018 3:01 pm

The BRANCH=next kernel has now been updated to the 4.19 tree following upstream kernel leaving release candidate state.

This has the upstream fix for the recently introduced csum error and switches to the upstream voltage monitor.

Note: The downstream /sys/devices/platform/soc/soc:firmware/get_throttled node is now deprecated (but currently functional). Users of this kernel should switch to /sys/class/hwmon/hwmon0/in0_lcrit_alarm.

User avatar
DougieLawson
Posts: 36165
Joined: Sun Jun 16, 2013 11:19 pm
Location: Basingstoke, UK
Contact: Website Twitter

Re: Moving Linux kernel to 4.19

Mon Oct 22, 2018 3:37 pm

4.19.0 still doesn't like my voicehat

Code: Select all

[    7.353564] voicehat-codec voicehat-codec: property 'voicehat_sdmode_delay' not found default 5 mS
[    7.367269] snd-rpi-simple soc:sound: Unable to allocate GPIO pin
[    7.367291] voicehat-codec voicehat-codec: ASoC: failed to probe component -2
[    7.367355] snd-rpi-simple soc:sound: ASoC: failed to instantiate card -2
[    7.367457] snd-rpi-simple soc:sound: Failed to register card -2
[    7.367486] snd-rpi-simple: probe of soc:sound failed with error -2

Code: Select all

010453.447: brfs: File read: /mfs/sd/config.txt
010456.230: brfs: File read: 3177 bytes
011168.545: brfs: File read: /mfs/sd/config.txt
011392.131: gpioman: gpioman_get_pin_num: pin DISPLAY_DSI_PORT not defined
011493.329: *** Restart logging
011493.404: brfs: File read: 3177 bytes
011941.277: brfs: File read: /mfs/sd/cmdline.txt
011941.385: Read command line from file 'cmdline.txt':
011941.453: 'dwc_otg.lpm_enable=0 console=serial0,115200 console=tty1 root=PARTUUID=86c71275-02 rootfstype=ext4 elevator=deadline fsck.repair=yes rootwait quiet splash plymouth.ignore-serial-consoles'
011941.781: brfs: File read: 187 bytes
018125.994: brfs: File read: /mfs/sd/kernel7.img
018126.060: Loading 'kernel7.img' to 0x8000 size 0x505508
018141.130: No kernel trailer - assuming DT-capable
018141.202: Trying Device Tree file 'bcm2710-rpi-3-b-plus.dtb'
018141.270: brfs: File read: 5264648 bytes
018464.163: brfs: File read: /mfs/sd/bcm2710-rpi-3-b-plus.dtb
018464.232: Loading 'bcm2710-rpi-3-b-plus.dtb' to 0x50d508 size 0x60b7
018481.851: dtdebug: delete_node(/__local_fixups__)
018491.725: dtdebug: /aliases:i2c_vc=i2c0
018501.511: dtdebug: /__symbols__:i2c_vc=i2c0
018508.889: dtdebug: /__overrides__:i2c_vc=i2c0
018523.036: dtdebug: /__overrides__:i2c_vc_baudrate=i2c0_baudrate
018527.489: dtdebug: /aliases:i2c=i2c1
018537.475: dtdebug: /__symbols__:i2c=i2c1
018544.983: dtdebug: /__overrides__:i2c=i2c1
018549.460: dtdebug: /aliases:i2c_arm=i2c1
018559.534: dtdebug: /__symbols__:i2c_arm=i2c1
018567.076: dtdebug: /__overrides__:i2c_arm=i2c1
018581.395: dtdebug: /__overrides__:i2c_baudrate=i2c1_baudrate
018595.868: dtdebug: /__overrides__:i2c_arm_baudrate=i2c1_baudrate
018602.798: dtparam: uart0_clkrate=48000000
018608.278: dtdebug: /__overrides__ has no uart0_clkrate property
018608.293: Unknown dtparam 'uart0_clkrate' - ignored
018608.359: brfs: File read: 24759 bytes
018865.465: brfs: File read: /mfs/sd/config.txt
018866.295: dterror: not a valid FDT - err -9
018866.307: Failed to load HAT overlay
018866.374: brfs: File read: 3177 bytes
019280.296: dtdebug: Opened overlay file 'overlays/googlevoicehat-soundcard.dtbo'
019320.534: brfs: File read: /mfs/sd/overlays/googlevoicehat-soundcard.dtbo
019339.119: Loaded overlay 'googlevoicehat-soundcard'
019339.191: dtparam: i2s=on
019339.519: dtdebug: /__overrides__ node not found
019344.688: dtdebug: Found override i2s
019344.724: dtdebug:   override i2s: string target 'status'
019353.791: dtdebug: Found fragment 0 (offset 36)
019364.634: dtdebug: merge_fragment(/soc/i2s@7e203000,/fragment@0/__overlay__)
019364.660: dtdebug:   +prop(status)
019366.713: dtdebug: merge_fragment() end
019366.769: dtdebug: Found fragment 1 (offset 112)
019370.014: dtdebug: merge_fragment(/soc/gpio@7e200000,/fragment@1/__overlay__)
019377.618: dtdebug: merge_fragment(/soc/gpio@7e200000/googlevoicehat_pins,/fragment@1/__overlay__/googlevoicehat_pins)
019377.650: dtdebug:   +prop(brcm,pins)
019380.392: dtdebug:   +prop(brcm,function)
019383.160: dtdebug:   +prop(brcm,pull)
019385.951: dtdebug:   +prop(phandle)
019388.704: dtdebug: merge_fragment() end
019388.739: dtdebug: merge_fragment() end
019388.821: dtdebug: Found fragment 2 (offset 260)
019389.039: dtdebug: merge_fragment(/,/fragment@2/__overlay__)
019403.350: dtdebug: merge_fragment(/voicehat-codec,/fragment@2/__overlay__/voicehat-codec)
019403.380: dtdebug:   +prop(#sound-dai-cells)
019406.512: dtdebug:   +prop(compatible)
019409.462: dtdebug:   +prop(pinctrl-names)
019412.596: dtdebug:   +prop(pinctrl-0)
019415.735: dtdebug:   +prop(sdmode-gpios)
019419.369: dtdebug:   +prop(status)
019422.502: dtdebug: merge_fragment() end
019422.537: dtdebug: merge_fragment() end
019422.621: dtdebug: Found fragment 3 (offset 464)
019441.674: dtdebug: merge_fragment(/soc/sound,/fragment@3/__overlay__)
019441.700: dtdebug:   +prop(compatible)
019442.969: dtdebug:   +prop(i2s-controller)
019444.907: dtdebug:   +prop(status)
019446.166: dtdebug: merge_fragment() end
019446.354: brfs: File read: 1259 bytes
019926.767: dtdebug: Failed to open overlay file 'overlays/i2s-mmap.dtbo'
020497.846: dtdebug: Failed to open overlay file 'overlays/i2s-mmap-overlay.dtb'
021068.922: dtdebug: Failed to open overlay file 'overlays/i2s-mmap.dtb'
021068.935: Failed to load overlay 'i2s-mmap'
021069.686: dtparam: spi=on
021074.995: dtdebug: Found override spi
021075.031: dtdebug:   override spi: string target 'status'
021084.568: dtparam: i2c_arm=on
021089.812: dtdebug: Found override i2c_arm
021089.848: dtdebug:   override i2c_arm: string target 'status'
021113.305: dtparam: uart1=off
021118.584: dtdebug: Found override uart1
021118.621: dtdebug:   override uart1: string target 'status'
022291.663: dtparam: cam0-pwdn-ctrl=28
022297.339: dtdebug: /__overrides__ has no cam0-pwdn-ctrl property
022297.355: Unknown dtparam 'cam0-pwdn-ctrl' - ignored
022297.419: dtparam: cam0-pwdn=5
022303.053: dtdebug: /__overrides__ has no cam0-pwdn property
022303.068: Unknown dtparam 'cam0-pwdn' - ignored
022314.896: dtparam: cam0-led-ctrl=28
022320.535: dtdebug: /__overrides__ has no cam0-led-ctrl property
022320.549: Unknown dtparam 'cam0-led-ctrl' - ignored
022320.612: dtparam: cam0-led=6
022326.270: dtdebug: /__overrides__ has no cam0-led property
022326.285: Unknown dtparam 'cam0-led' - ignored
022326.351: gpioman: gpioman_get_pin_num: pin EMMC_ENABLE not defined
022326.441: dtparam: arm_freq=1400000000
022331.982: dtdebug: Found override arm_freq
022332.031: dtdebug:   override arm_freq: cell target clock-frequency @ offset 0 (size 4)
022347.226: dtdebug:   override arm_freq: cell target clock-frequency @ offset 0 (size 4)
022362.569: dtdebug:   override arm_freq: cell target clock-frequency @ offset 0 (size 4)
022377.946: dtdebug:   override arm_freq: cell target clock-frequency @ offset 0 (size 4)
022393.481: dtparam: core_freq=400000000
022399.203: dtdebug: /__overrides__ has no core_freq property
022399.216: Unknown dtparam 'core_freq' - ignored
022411.808: dtdebug: delete_node(/hat)
022456.812: Device tree loaded to 0x2eff9800 (size 0x6731)
024884.677: vchiq_core: vchiq_init_state: slot_zero = 0xf7880000, is_master = 1
024894.525: TV service:host side not connected, dropping notification 0x00000002, 0x00000002, 0x00000051

Code: Select all

root@hitchhiker:~ # raspi-gpio get 16
GPIO 16: level=0 fsel=1 func=OUTPUT
root@hitchhiker:~ # grep 16 /sys/kernel/debug/pinctrl/3f200000.gpio/{pinmux-,}pins
grep: /sys/kernel/debug/pinctrl/3f200000.gpio/pinmux-pins: No such file or directory
grep: /sys/kernel/debug/pinctrl/3f200000.gpio/pins: No such file or directory
root@hitchhiker:~ #
Note: Having anything humorous in your signature is completely banned on this forum. Wear a tin-foil hat and you'll get a ban.

Any DMs sent on Twitter will be answered next month.

This is a doctor free zone.

6by9
Raspberry Pi Engineer & Forum Moderator
Raspberry Pi Engineer & Forum Moderator
Posts: 7314
Joined: Wed Dec 04, 2013 11:27 am
Location: ZZ9 Plural Z Alpha, aka just outside Cambridge.

Re: Moving Linux kernel to 4.19

Tue Oct 23, 2018 12:47 pm

Re: Voicehat not working - the dtoverlay appears to be incorrect. It seems that the sdmode-gpios entry needs to be under the sound node, not the voicehat-codec one. Either that or the devm_gpiod_get call in voicehat_component_probe is passing in the wrong device. Pass as to what/where this has changed since 4.14.

The pinctrl setup appears to be totally unnecessary. It changes the config from

Code: Select all

pin 16 (gpio16): voicehat-codec pinctrl-bcm2835:16 function gpio_out group gpio16
to

Code: Select all

pin 16 (gpio16): (MUX UNCLAIMED) pinctrl-bcm2835:16
The pin is an I/O pin anyway, and I'm not totally clear what the benefit of claiming the mux is. The card works fine with or without it.
Software Engineer at Raspberry Pi Trading. Views expressed are still personal views.
I'm not interested in doing contracts for bespoke functionality - please don't ask.

User avatar
DougieLawson
Posts: 36165
Joined: Sun Jun 16, 2013 11:19 pm
Location: Basingstoke, UK
Contact: Website Twitter

Re: Moving Linux kernel to 4.19

Tue Oct 23, 2018 1:38 pm

Is there a simple hack to https://raw.githubusercontent.com/raspb ... verlay.dts that I can do to fix it?

Or is there some arcane voodoo that you folks in Raspberry Pi Towers need to enact.
Note: Having anything humorous in your signature is completely banned on this forum. Wear a tin-foil hat and you'll get a ban.

Any DMs sent on Twitter will be answered next month.

This is a doctor free zone.

6by9
Raspberry Pi Engineer & Forum Moderator
Raspberry Pi Engineer & Forum Moderator
Posts: 7314
Joined: Wed Dec 04, 2013 11:27 am
Location: ZZ9 Plural Z Alpha, aka just outside Cambridge.

Re: Moving Linux kernel to 4.19

Tue Oct 23, 2018 1:43 pm

DougieLawson wrote:
Tue Oct 23, 2018 1:38 pm
Is there a simple hack to https://raw.githubusercontent.com/raspb ... verlay.dts that I can do to fix it?

Or is there some arcane voodoo that you folks in Raspberry Pi Towers need to enact.
Keep fragments 0&1 as is.
Replace fragments 2&3 with

Code: Select all

	fragment@2 {
		target-path = "/";
		__overlay__ {
			voicehat-codec {
				#sound-dai-cells = <0>;
				compatible = "google,voicehat";
				pinctrl-names = "default";
				pinctrl-0 = <&googlevoicehat_pins>;
 				status = "okay";
			};
		};
	};

	fragment@3 {
		target = <&sound>;
		__overlay__ {
			compatible = "googlevoicehat,googlevoicehat-soundcard";
			i2s-controller = <&i2s>;
			sdmode-gpios= <&gpio 16 0>;
			status = "okay";
		};
	};
Net result is only moving the "sdmode-gpios= <&gpio 16 0>;" line from fragment 2 to fragment 3.

I'll spend a further few mins seeing if there is an obvious change in the sound frameworks that show why/how things have changed. As I said, I'm not clear whether this is that the overlay has always been wrong and the checking has been tightened up, or has the framework changed so that the driver is now being given a different pointer.
Software Engineer at Raspberry Pi Trading. Views expressed are still personal views.
I'm not interested in doing contracts for bespoke functionality - please don't ask.

6by9
Raspberry Pi Engineer & Forum Moderator
Raspberry Pi Engineer & Forum Moderator
Posts: 7314
Joined: Wed Dec 04, 2013 11:27 am
Location: ZZ9 Plural Z Alpha, aka just outside Cambridge.

Re: Moving Linux kernel to 4.19

Tue Oct 23, 2018 2:14 pm

6by9 wrote:
Tue Oct 23, 2018 1:43 pm
I'll spend a further few mins seeing if there is an obvious change in the sound frameworks that show why/how things have changed. As I said, I'm not clear whether this is that the overlay has always been wrong and the checking has been tightened up, or has the framework changed so that the driver is now being given a different pointer.
OK, this looks like a driver error, not overlay (although it can be worked around by altering it)
Diffs from 4.14 to 4.19

Code: Select all

-static int voicehat_codec_probe(struct snd_soc_codec *codec) {
-  struct voicehat_priv *voicehat = snd_soc_codec_get_drvdata(codec);
+static int voicehat_component_probe(struct snd_soc_component *component) {
+  struct voicehat_priv *voicehat = snd_soc_component_get_drvdata(component);
 
-  voicehat->sdmode_gpio = devm_gpiod_get(codec->dev, "sdmode", GPIOD_OUT_LOW);
+  voicehat->sdmode_gpio = devm_gpiod_get(component->card->dev, "sdmode", GPIOD_OUT_LOW);
   if (IS_ERR(voicehat->sdmode_gpio)) {
-    dev_err(codec->dev, "Unable to allocate GPIO pin\n");
+    dev_err(component->card->dev, "Unable to allocate GPIO pin\n");
     return PTR_ERR(voicehat->sdmode_gpio);
   }
I'm not following why it's changed, but https://github.com/raspberrypi/linux/co ... 76c07f14f6 is the cause.
Software Engineer at Raspberry Pi Trading. Views expressed are still personal views.
I'm not interested in doing contracts for bespoke functionality - please don't ask.

6by9
Raspberry Pi Engineer & Forum Moderator
Raspberry Pi Engineer & Forum Moderator
Posts: 7314
Joined: Wed Dec 04, 2013 11:27 am
Location: ZZ9 Plural Z Alpha, aka just outside Cambridge.

Re: Moving Linux kernel to 4.19

Tue Oct 23, 2018 2:44 pm

https://github.com/raspberrypi/linux/pull/2727 should fix up the driver instead of wanting to hack the dtoverlay.
Software Engineer at Raspberry Pi Trading. Views expressed are still personal views.
I'm not interested in doing contracts for bespoke functionality - please don't ask.

User avatar
DougieLawson
Posts: 36165
Joined: Sun Jun 16, 2013 11:19 pm
Location: Basingstoke, UK
Contact: Website Twitter

Re: Moving Linux kernel to 4.19

Tue Oct 23, 2018 5:36 pm

Tried a BRANCH=next rpi-update to bbd7c1a515270548d914d53e0e27eb6a1ff3c42c

Code: Select all

[    6.426546] voicehat-codec voicehat-codec: property 'voicehat_sdmode_delay' not found default 5 mS
[    6.427592] snd-rpi-simple soc:sound: Unable to allocate GPIO pin
[    6.427610] voicehat-codec voicehat-codec: ASoC: failed to probe component -2
[    6.427671] snd-rpi-simple soc:sound: ASoC: failed to instantiate card -2
[    6.427864] snd-rpi-simple soc:sound: Failed to register card -2
[    6.427893] snd-rpi-simple: probe of soc:sound failed with error -2
Still not working.

It's time to build a 4.19 kernel locally.
Note: Having anything humorous in your signature is completely banned on this forum. Wear a tin-foil hat and you'll get a ban.

Any DMs sent on Twitter will be answered next month.

This is a doctor free zone.

dom
Raspberry Pi Engineer & Forum Moderator
Raspberry Pi Engineer & Forum Moderator
Posts: 5331
Joined: Wed Aug 17, 2011 7:41 pm
Location: Cambridge

Re: Moving Linux kernel to 4.19

Wed Oct 24, 2018 11:56 am

rpi-update kernel now includes the "Google VoiceHAT fixups" commit.

User avatar
DougieLawson
Posts: 36165
Joined: Sun Jun 16, 2013 11:19 pm
Location: Basingstoke, UK
Contact: Website Twitter

Re: Moving Linux kernel to 4.19

Wed Oct 24, 2018 7:34 pm

dom wrote:
Wed Oct 24, 2018 11:56 am
rpi-update kernel now includes the "Google VoiceHAT fixups" commit.
Thank you. "OK Google" was just able to tell me the weather forecast running 4.19.0-v7+ #1157

Next problems:

Code: Select all

[  116.749009] brcmfmac: brcmf_run_escan: error (-52)
[  116.749028] brcmfmac: brcmf_cfg80211_scan: scan error (-52)
[  117.751514] brcmfmac: brcmf_run_escan: error (-52)
[  117.751530] brcmfmac: brcmf_cfg80211_scan: scan error (-52)
[  118.753318] brcmfmac: brcmf_run_escan: error (-52)
[  118.753326] brcmfmac: brcmf_cfg80211_scan: scan error (-52)
and

Code: Select all

[   41.277162] FS-Cache: Duplicate cookie detected
[   41.277184] FS-Cache: O-cookie c=6ae20e1e [p=e1c2ce2c fl=212 nc=0 na=0]
[   41.277188] FS-Cache: O-cookie d=  (null) n=  (null)
[   41.277193] FS-Cache: O-key=[10] '0400020008010a0101e6'
[   41.277221] FS-Cache: N-cookie c=1c8fd3c5 [p=e1c2ce2c fl=2 nc=0 na=1]
[   41.277224] FS-Cache: N-cookie d=bcada285 n=c5bb4bfe
[   41.277226] FS-Cache: N-key=[10] '0400020008010a0101e6'
[   44.472411] FS-Cache: Duplicate cookie detected
[   44.472464] FS-Cache: O-cookie c=1c8fd3c5 [p=e1c2ce2c fl=222 nc=0 na=1]
[   44.472468] FS-Cache: O-cookie d=bcada285 n=c5bb4bfe
[   44.472473] FS-Cache: O-key=[10] '0400020008010a0101e6'
[   44.472507] FS-Cache: N-cookie c=6ae20e1e [p=e1c2ce2c fl=2 nc=0 na=1]
[   44.472510] FS-Cache: N-cookie d=bcada285 n=a594f931
[   44.472513] FS-Cache: N-key=[10] '0400020008010a0101e6'
[   44.472859] FS-Cache: Duplicate cookie detected
[   44.472870] FS-Cache: O-cookie c=1c8fd3c5 [p=e1c2ce2c fl=222 nc=0 na=1]
[   44.472873] FS-Cache: O-cookie d=bcada285 n=c5bb4bfe
[   44.472876] FS-Cache: O-key=[10] '0400020008010a0101e6'
[   44.472902] FS-Cache: N-cookie c=6ae20e1e [p=e1c2ce2c fl=2 nc=0 na=1]
[   44.472905] FS-Cache: N-cookie d=bcada285 n=7ffe9099
[   44.472908] FS-Cache: N-key=[10] '0400020008010a0101e6'
Note: Having anything humorous in your signature is completely banned on this forum. Wear a tin-foil hat and you'll get a ban.

Any DMs sent on Twitter will be answered next month.

This is a doctor free zone.

dom
Raspberry Pi Engineer & Forum Moderator
Raspberry Pi Engineer & Forum Moderator
Posts: 5331
Joined: Wed Aug 17, 2011 7:41 pm
Location: Cambridge

Re: Moving Linux kernel to 4.19

Thu Oct 25, 2018 11:33 am

The duplicate cookie issue has been reported on other platforms.
Not found any answers so far.

Edit: Do you see this on multiple pi's? Are you using an nfs or samba mount?

User avatar
DougieLawson
Posts: 36165
Joined: Sun Jun 16, 2013 11:19 pm
Location: Basingstoke, UK
Contact: Website Twitter

Re: Moving Linux kernel to 4.19

Thu Oct 25, 2018 12:17 pm

I'm seeing it on lots of pis. All of them share two or three folders on my Zyxel NAS box.

I'll see if I can see a pattern.

Edit: It's only on my three raspberries that have the brcmfmac43455 WiFi/BT hardware on-board.
Note: Having anything humorous in your signature is completely banned on this forum. Wear a tin-foil hat and you'll get a ban.

Any DMs sent on Twitter will be answered next month.

This is a doctor free zone.

6by9
Raspberry Pi Engineer & Forum Moderator
Raspberry Pi Engineer & Forum Moderator
Posts: 7314
Joined: Wed Dec 04, 2013 11:27 am
Location: ZZ9 Plural Z Alpha, aka just outside Cambridge.

Re: Moving Linux kernel to 4.19

Mon Oct 29, 2018 2:20 pm

For anyone trying to use the Unicam driver or V4L2 camera driver, I'm aware that they haven't been fully merged onto 4.19, and I'm working on it.
Software Engineer at Raspberry Pi Trading. Views expressed are still personal views.
I'm not interested in doing contracts for bespoke functionality - please don't ask.

hibikiq
Posts: 2
Joined: Thu Nov 01, 2018 9:28 pm

Re: Moving Linux kernel to 4.19

Thu Nov 01, 2018 9:39 pm

Sorry if dumb question, but is there a way how to access .config file of this kernel?
I am asking because 4.19 is first version of kernel that support my wifi card Archer T2UH https://www.tp-link.com/us/products/det ... r-T2UH.htm , already compiled it for my x86 notebook and it works fine, unfortunately it looks like it is not included in raspberry release (or there is something alse wrong).
Raspberry says:

Code: Select all

[    2.313277] usb 1-1.2: new high-speed USB device number 4 using dwc_otg
[    2.459865] usb 1-1.2: New USB device found, idVendor=148f, idProduct=761a, bcdDevice= 1.00
[    2.466530] usb 1-1.2: New USB device strings: Mfr=1, Product=2, SerialNumber=3
[    2.469838] usb 1-1.2: Product: WiFi
[    2.473041] usb 1-1.2: Manufacturer: MediaTek
[    2.476230] usb 1-1.2: SerialNumber: 1.0
My x86 notebook:

Code: Select all

[38466.608540] usb 1-2.3.4: new high-speed USB device number 15 using xhci_hcd
[38466.724873] usb 1-2.3.4: New USB device found, idVendor=148f, idProduct=761a, bcdDevice= 1.00
[38466.724881] usb 1-2.3.4: New USB device strings: Mfr=1, Product=2, SerialNumber=3
[38466.724884] usb 1-2.3.4: Product: WiFi
[38466.724887] usb 1-2.3.4: Manufacturer: MediaTek
[38466.724889] usb 1-2.3.4: SerialNumber: 1.0
[38466.836724] usb 1-2.3.4: reset high-speed USB device number 15 using xhci_hcd
[38466.945253] mt76x0 1-2.3.4:1.0: ASIC revision: 76100002 MAC revision: 76502000
[38467.948765] BBP version f000f200
[38467.968839] mt76x0 1-2.3.4:1.0: EEPROM ver:02 fae:01
[38467.969027] mt76x0 1-2.3.4:1.0: EEPROM country region 01 (channels 1-13)
[38467.975171] ieee80211 phy1: Selected rate control algorithm 'minstrel_ht'
[38467.975874] usbcore: registered new interface driver mt76x0
And

Code: Select all

lsmod  | grep mt7
mt76x0                118784  0
mt76                   40960  1 mt76x0
mac80211              823296  3 mt76,mt76x0,iwlmvm
cfg80211              765952  4 mt76x0,iwlmvm,iwlwifi,mac80211
usbcore               290816  11 xhci_hcd,mt76x0,usbnet,snd_usb_audio,usbhid,snd_usbmidi_lib,uvcvideo,btusb,xhci_pci,cdc_ether,r8152

dom
Raspberry Pi Engineer & Forum Moderator
Raspberry Pi Engineer & Forum Moderator
Posts: 5331
Joined: Wed Aug 17, 2011 7:41 pm
Location: Cambridge

Re: Moving Linux kernel to 4.19

Fri Nov 02, 2018 1:55 pm

hibikiq wrote:
Thu Nov 01, 2018 9:39 pm
Sorry if dumb question, but is there a way how to access .config file of this kernel?
Same as with any raspbian kernel:

Code: Select all

sudo modprobe configs
zcat /proc/config.gz

hibikiq
Posts: 2
Joined: Thu Nov 01, 2018 9:28 pm

Re: Moving Linux kernel to 4.19

Sat Nov 03, 2018 3:20 pm

Thank you.
Modules mt76.ko and mt76x0.ko are indeed not configured to compile

Code: Select all

2072:CONFIG_MT7601U=m
2073:# CONFIG_MT76x0U is not set
I tried to crosscompile them, but resulting modules not working so far

Code: Select all

modprobe mt76x0 
modprobe: ERROR: could not insert 'mt76x0': Exec format error
I'll wait until this makes it to the mainline.

EDIT: My bad, I compiled against vanilla kernel version

Code: Select all

vermagic:       4.19.0 mod_unload modversions ARMv6 p2v8 
while native raspberry modules are

Code: Select all

vermagic:       4.19.0+ mod_unload modversions ARMv6 p2v8

jimbojones
Posts: 13
Joined: Sun Apr 15, 2018 2:33 pm

Re: Moving Linux kernel to 4.19

Sat Nov 10, 2018 12:25 am

Just wanted to throw my 2 cents in (even though it might not be wanted, especially as I'm running a non-supported configuration :| )

I tried compiling the 4.19.y kernel for my 3B+ using the arm64 architecture. Unfortunately something is wrong with the config, as the pi refuses to boot to the new kernel. I posted an issue to github https://github.com/raspberrypi/linux/issues/2743 with more details.

Reverting to my arm64 build of the rpi-4.14.y kernel (4.14.79-v8+ to be precise) got my pi back up and running.

User avatar
kozman
Posts: 53
Joined: Tue Sep 11, 2018 3:40 pm

Re: Moving Linux kernel to 4.19

Mon Nov 12, 2018 6:36 pm

Just curious how much more performant 4.19 is versus current 4.14.x. Anyone do any benchmarks? Looks like the upcoming 4.19.2 is going to be a huge point release.

User avatar
kozman
Posts: 53
Joined: Tue Sep 11, 2018 3:40 pm

Re: Moving Linux kernel to 4.19

Wed Nov 21, 2018 7:15 pm

kozman wrote:
Mon Nov 12, 2018 6:36 pm
Just curious how much more performant 4.19 is versus current 4.14.x. Anyone do any benchmarks? Looks like the upcoming 4.19.2 is going to be a huge point release.
Well, I took the plunge and upped to 4.19.2 and IMHO it doesn't seem to be too be much snapper than 4.14. :?

swahren
Posts: 108
Joined: Mon Sep 19, 2016 5:24 pm
Location: Germany

Re: Moving Linux kernel to 4.19

Sun Nov 25, 2018 12:45 pm

Hi, this weekend i wanted to setup an access point on my Raspberry Pi 3 A+ using builtin wifi with a recent kernel. Unfortunately the hostapd 2.4 shipped with Raspbian Stretch failed with Linux 4.18 and newer:

Code: Select all

rfkill: initial event: idx=0 type=2 op=0 soft=0 hard=0
rfkill: initial event: idx=1 type=1 op=0 soft=0 hard=0
nl80211: Using driver-based roaming
nl80211: TDLS supported
nl80211: Supported cipher 00-0f-ac:1
nl80211: Supported cipher 00-0f-ac:5
nl80211: Supported cipher 00-0f-ac:2
nl80211: Supported cipher 00-0f-ac:4
nl80211: Supported cipher 00-0f-ac:6
nl80211: Using driver-based off-channel TX
nl80211: Supported vendor command: vendor_id=0x1018 subcmd=1
nl80211: Use separate P2P group interface (driver advertised support)
nl80211: Enable multi-channel concurrent (driver advertised support)
nl80211: use P2P_DEVICE support
nl80211: Disable use_monitor with device_ap_sme since no monitor mode support detected
nl80211: interface wlan0 in phy phy0
nl80211: Set mode ifindex 3 iftype 3 (AP)
nl80211: Setup AP(wlan0) - device_ap_sme=1 use_monitor=0
nl80211: Subscribe to mgmt frames with AP handle 0x114350 (device SME)
nl80211: Register frame type=0xd0 (WLAN_FC_STYPE_ACTION) nl_handle=0x114350 match=
nl80211: Register frame command failed (type=208): ret=-22 (Invalid argument)
nl80211: Register frame match - hexdump(len=0): [NULL]
nl80211: Could not configure driver mode
nl80211: deinit ifname=wlan0 disabled_11b_rates=0
nl80211: Remove monitor interface: refcount=0
nl80211: Remove beacon (ifindex=3)
netlink: Operstate: ifindex=3 linkmode=0 (kernel-control), operstate=6 (IF_OPER_UP)
nl80211: Set mode ifindex 3 iftype 2 (STATION)
nl80211: Teardown AP(wlan0) - device_ap_sme=1 use_monitor=0
nl80211 driver initialization failed.
I was able to narrow down the issue to this commit 1204aa17f3b4 ("brcmfmac: set WIPHY_FLAG_HAVE_AP_SME flag"). I already reported this to linux-wireless and the author of this commit explained me that the reason for this regression is the ancient version of hostapd.

So i installed hostapd-2.6 from the Buster repo and hostapd started, but now the rpi-4.19.4 Kernel cause issues:

Code: Select all

[   16.471978] brcmfmac: brcmf_escan_timeout: timer expired
[   16.919041] brcmfmac: brcmf_vif_set_mgmt_ie: vndr ie set error : -52
So the following combinations worked for me:
mainline-4.20-rc1 (without 1204aa17f3b4) + hostapd 2.4
mainline-4.20-rc1 (without 1204aa17f3b4) + hostapd 2.6
rpi-4.14.82 + hostapd 2.4

Btw Are these nasty downstream hacks on brcmfmac really necessary anymore:
f3fac5f8dfd047cda ("brcm: adds support for BCM43341 wifi")

I never needed them with a mainline kernel and i think these cause more trouble than help.

paul433
Posts: 18
Joined: Sun Dec 30, 2012 10:46 pm

Re: Moving Linux kernel to 4.19

Mon Nov 26, 2018 12:11 am

This dwc-otg driver problem is back with 4.19.y, https://github.com/raspberrypi/linux/issues/2450

It does not appear that this commit has made it into 4.19 https://github.com/raspberrypi/linux/co ... 56fa68d57d

It does not apply cleanly, but I think I merged it properly,rebuilt the kernel, and it does resolve the issue.

Return to “Advanced users”